package client;

import java.rmi.*;
import java.io.*;
import java.net.MalformedURLException;
import server.DBInterface;
import server.EmployeeRecord;

public class DBClient {
   public static void main(String[] args) {
      EmployeeRecord record;

      try {
          DBInterface db = 
            (DBInterface)Naming.lookup("DBImplementation");

          record = new EmployeeRecord("123-45-6789", "William Blake");
          db.writeRecord(record);

          record = new EmployeeRecord("000-11-2222", "John Dunne");
          db.writeRecord(record);

          db.rewind();
          while (db.moreRecords()) {
              record = db.readRecord();
              System.out.println("Ssn: " + record.getSsn());
              System.out.println("Name: " + record.getName());
          }
       } catch (MalformedURLException e) {
          error(e);
       } catch (NotBoundException e) {
          error(e);
       } catch (RemoteException e) {
          error(e);
       } catch (EOFException e) {
          error(e);
       } catch (IOException e) {
          error(e);
       }
    }

    private static void error(Exception e) {
       System.out.println("DBClient exception: " + e.getMessage());
       e.printStackTrace();
    }

}
